diff -Naur --no-dereference a/net/hsr/hsr_proc.c b/net/hsr/hsr_proc.c
--- a/net/hsr/hsr_proc.c	1969-12-31 19:00:00.000000000 -0500
+++ b/net/hsr/hsr_proc.c	2023-04-15 15:47:48.690088712 -0400
@@ -0,0 +1,673 @@
+// SPDX-License-Identifier: GPL-2.0
+/* hsr_proc.c : procfs file for HSR and PRP driver
+ *
+ * Copyright (C) 2018-2020 Texas Instruments Incorporated - http://www.ti.com
+ *
+ * Author(s):
+ *     Murali Karicheri <m-karicheri2@ti.com>
+ */
+#include <linux/netdevice.h>
+#include <linux/proc_fs.h>
+
+#include "hsr_main.h"
+
+#define BUF_SIZE 64
+#define LRE_STAT_OFS(m) offsetof(struct lre_stats, m)
+
+static const char *const hsr_lre_stats[] = {
+	"lreTxA",
+	"lreTxB",
+	"lreTxC",
+	"lreErrWrongLanA",
+	"lreErrWrongLanB",
+	"lreErrWrongLanC",
+	"lreRxA",
+	"lreRxB",
+	"lreRxC",
+	"lreErrorsA",
+	"lreErrorsB",
+	"lreErrorsC",
+	"lreNodes",
+	"lreProxyNodes",
+	"lreUniqueRxA",
+	"lreUniqueRxB",
+	"lreUniqueRxC",
+	"lreDuplicateRxA",
+	"lreDuplicateRxB",
+	"lreDuplicateRxC",
+	"lreMultiRxA",
+	"lreMultiRxB",
+	"lreMultiRxC",
+	"lreOwnRxA",
+	"lreOwnRxB",
+};
+
+static int hsr_lre_stats_show(struct seq_file *sfp, void *v)
+{
+	struct hsr_priv *priv = (struct hsr_priv *)sfp->private;
+	struct lre_stats lower_stats, *upper_stats;
+	int ret = 0, i;
+	u32 *ptr;
+
+	upper_stats = &priv->lre_stats;
+	if (priv->rx_offloaded) {
+		ret = hsr_lredev_get_lre_stats(priv, &lower_stats);
+		if (ret < 0) {
+			seq_puts(sfp, "Error in retrieving the stats\n");
+			return 0;
+		}
+		ptr = (u32 *)&lower_stats;
+	} else {
+		ptr = (u32 *)upper_stats;
+	}
+
+	seq_puts(sfp, "LRE statistics:\n");
+	seq_printf(sfp, "Rx Offloaded: %d\n", priv->rx_offloaded);
+	for (i = 0; i < ARRAY_SIZE(hsr_lre_stats); i++) {
+		/* for rx_c and tx_c, retrieve stats from hsr/prp device
+		 * lre stats. Rest of the stats are retrieved from
+		 * lower device.
+		 */
+		if (!strcmp("lreTxC", hsr_lre_stats[i])) {
+			seq_printf(sfp, "\n     %s: %d",
+				   hsr_lre_stats[i],
+				   upper_stats->cnt_tx_c);
+			continue;
+		}
+
+		if (!strcmp("lreRxC", hsr_lre_stats[i])) {
+			seq_printf(sfp, "\n     %s: %d",
+				   hsr_lre_stats[i],
+				   upper_stats->cnt_rx_c);
+			continue;
+		}
+		seq_printf(sfp, "\n     %s: %d", hsr_lre_stats[i],
+			   *(ptr + i));
+	}
+	seq_puts(sfp, "\n");
+
+	return 0;
+}
+
+static int hsr_lre_stats_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, hsr_lre_stats_show, PDE_DATA(inode));
+}
+
+static const struct proc_ops hsr_lre_stats_fops = {
+	.proc_open		= hsr_lre_stats_open,
+	.proc_read		= seq_read,
+	.proc_lseek		= seq_lseek,
+	.proc_release	= single_release,
+};
+
+static int hsr_node_show(struct seq_file *sfp, int index,
+			 struct lre_node_table_entry *entry)
+{
+	seq_printf(sfp, "\nNode[%u]:\n", index);
+	seq_printf(sfp, "MAC ADDR: %02x:%02x:%02x:%02x:%02x:%02x\n",
+		   entry->mac_address[0],
+		   entry->mac_address[1],
+		   entry->mac_address[2],
+		   entry->mac_address[3],
+		   entry->mac_address[4],
+		   entry->mac_address[5]);
+
+	switch (entry->node_type) {
+	case IEC62439_3_DANP:
+		seq_puts(sfp, "DANP\n");
+		break;
+	case IEC62439_3_REDBOXP:
+		seq_puts(sfp, "REDBOXP\n");
+		break;
+	case IEC62439_3_VDANP:
+		seq_puts(sfp, "VDANP\n");
+		break;
+	case IEC62439_3_DANH:
+		seq_puts(sfp, "DANH\n");
+		break;
+	case IEC62439_3_REDBOXH:
+		seq_puts(sfp, "REDBOXH\n");
+		break;
+	case IEC62439_3_VDANH:
+		seq_puts(sfp, "VDANH\n");
+		break;
+	default:
+		seq_printf(sfp, "Unknown node type %u\n", entry->node_type);
+		break;
+	};
+
+	seq_printf(sfp, "Time Last Seen: RxA=%u RxB=%u\n",
+		   entry->time_last_seen_a,
+		   entry->time_last_seen_b);
+	return 0;
+}
+
+static int hsr_node_table_show(struct seq_file *sfp, void *v)
+{
+	struct hsr_priv *priv = (struct hsr_priv *)sfp->private;
+	struct lre_node_table_entry *nt_table;
+	int ret = 0, count, i;
+
+	nt_table = kcalloc(LRE_MAX_NT_ENTRIES, sizeof(*nt_table), GFP_KERNEL);
+	if (!nt_table)
+		return -ENODEV;
+
+	count = hsr_lredev_get_node_table(priv, nt_table,
+					  LRE_MAX_NT_ENTRIES);
+	if (count < 0)
+		count = 0;
+
+	seq_printf(sfp, "\nRemote nodes in network: %u\n", count);
+
+	if (!count)
+		return ret;
+
+	for (i = 0; i < count; i++)
+		hsr_node_show(sfp, i, &nt_table[i]);
+	return ret;
+}
+
+static int hsr_node_table_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, hsr_node_table_show, PDE_DATA(inode));
+}
+
+static const struct proc_ops hsr_node_table_fops = {
+	.proc_open		= hsr_node_table_open,
+	.proc_read		= seq_read,
+	.proc_lseek		= seq_lseek,
+	.proc_release	= single_release,
+};
+
+static inline int get_set_param(struct hsr_priv *priv,
+				const char __user *buffer, size_t count,
+				enum lredev_attr_id id)
+{
+	struct lredev_attr temp_attr;
+	char cmd_buffer[BUF_SIZE];
+	int ret = -EINVAL;
+	u32 val;
+
+	if (count > (sizeof(cmd_buffer) - 1))
+		goto err;
+
+	if (copy_from_user(cmd_buffer, buffer, count)) {
+		ret = -EFAULT;
+		goto err;
+	}
+	cmd_buffer[count] = '\0';
+	ret = kstrtou32(cmd_buffer, 0, &val);
+	if (ret < 0)
+		goto err;
+
+	/* TODO. Update mode. Check if anything else needed for
+	 * non offload case
+	 */
+	temp_attr.id = id;
+	switch (id) {
+	case LREDEV_ATTR_ID_HSR_MODE:
+		if (val > IEC62439_3_HSR_MODE_M) {
+			ret = -EINVAL;
+			goto err;
+		}
+		if (!priv->rx_offloaded) {
+			priv->hsr_mode = (enum iec62439_3_hsr_modes)val;
+			return 0;
+		}
+		temp_attr.mode = (enum iec62439_3_hsr_modes)val;
+		break;
+
+	case LREDEV_ATTR_ID_PRP_TR:
+		if (val > IEC62439_3_TR_PASS_RCT) {
+			ret = -EINVAL;
+			goto err;
+		}
+		if (!priv->rx_offloaded) {
+			priv->prp_tr = (enum iec62439_3_tr_modes)val;
+			goto out;
+		}
+		temp_attr.tr_mode = (enum iec62439_3_tr_modes)val;
+		break;
+
+	case LREDEV_ATTR_ID_DD_MODE:
+		if (val > IEC62439_3_DD) {
+			ret = -EINVAL;
+			goto err;
+		}
+		if (!priv->rx_offloaded) {
+			priv->dd_mode = (enum iec62439_3_dd_modes)val;
+			goto out;
+		}
+		temp_attr.dd_mode = (enum iec62439_3_dd_modes)val;
+		break;
+
+	case LREDEV_ATTR_ID_DLRMT:
+		if (!priv->rx_offloaded) {
+			priv->dlrmt = val;
+			goto out;
+		}
+		temp_attr.dl_reside_max_time = val;
+		break;
+
+	case LREDEV_ATTR_ID_CLEAR_NT:
+		if (val > IEC62439_3_CLEAR_NT) {
+			ret = -EINVAL;
+			goto err;
+		}
+		if (!priv->rx_offloaded) {
+			priv->clear_nt_cmd =
+				(enum iec62439_3_clear_nt_cmd)val;
+			goto out;
+		}
+		temp_attr.clear_nt_cmd = (enum iec62439_3_clear_nt_cmd)val;
+		break;
+	default:
+		ret = -EINVAL;
+		goto err;
+	}
+
+	/* pass this to lower layer device, i.e slave-1 */
+	ret = hsr_lredev_attr_set(priv, &temp_attr);
+	if (ret)
+		return ret;
+
+	/* update the local copy */
+	switch (id) {
+	case LREDEV_ATTR_ID_HSR_MODE:
+		priv->hsr_mode = temp_attr.mode;
+		break;
+	case LREDEV_ATTR_ID_PRP_TR:
+		priv->prp_tr = temp_attr.tr_mode;
+		break;
+	case LREDEV_ATTR_ID_DD_MODE:
+		priv->dd_mode = temp_attr.dd_mode;
+		break;
+	case LREDEV_ATTR_ID_CLEAR_NT:
+		priv->clear_nt_cmd = temp_attr.clear_nt_cmd;
+		break;
+	default: /* LREDEV_ATTR_ID_DLRMT */
+		priv->dlrmt = temp_attr.dl_reside_max_time;
+		break;
+	}
+out:
+	return 0;
+err:
+	return ret;
+}
+
+static int hsr_mode_show(struct seq_file *sfp, void *v)
+{
+	struct hsr_priv *priv = (struct hsr_priv *)sfp->private;
+	struct lredev_attr temp_attr;
+	int err;
+
+	if (!priv->rx_offloaded) {
+		seq_printf(sfp, "%u\n", priv->hsr_mode);
+		return 0;
+	}
+
+	temp_attr.id = LREDEV_ATTR_ID_HSR_MODE;
+	err = hsr_lredev_attr_get(priv, &temp_attr);
+	if (err)
+		return err;
+
+	seq_printf(sfp, "%u\n", temp_attr.mode);
+	return 0;
+}
+
+static int hsr_mode_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, hsr_mode_show, PDE_DATA(inode));
+}
+
+static ssize_t hsr_mode_store(struct file *file,
+			      const char __user *buffer,
+			      size_t count, loff_t *pos)
+{
+	struct hsr_priv *priv = (struct hsr_priv *)PDE_DATA(file_inode(file));
+	int err;
+
+	err = get_set_param(priv, buffer, count, LREDEV_ATTR_ID_HSR_MODE);
+	if (err)
+		return err;
+
+	return  count;
+}
+
+static const struct proc_ops hsr_mode_fops = {
+	.proc_open		= hsr_mode_open,
+	.proc_read		= seq_read,
+	.proc_write		= hsr_mode_store,
+	.proc_lseek		= seq_lseek,
+	.proc_release	= single_release,
+};
+
+static int prp_tr_show(struct seq_file *sfp, void *v)
+{
+	struct hsr_priv *priv = (struct hsr_priv *)sfp->private;
+	struct lredev_attr temp_attr;
+	int err;
+
+	if (!priv->rx_offloaded) {
+		seq_printf(sfp, "%u\n", priv->prp_tr);
+		return 0;
+	}
+
+	temp_attr.id = LREDEV_ATTR_ID_PRP_TR;
+	err = hsr_lredev_attr_get(priv, &temp_attr);
+	if (err)
+		return err;
+
+	seq_printf(sfp, "%u\n", temp_attr.tr_mode);
+	return 0;
+}
+
+static int prp_tr_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, prp_tr_show, PDE_DATA(inode));
+}
+
+static ssize_t prp_tr_store(struct file *file,
+			    const char __user *buffer,
+			    size_t count, loff_t *pos)
+{
+	struct hsr_priv *priv = (struct hsr_priv *)PDE_DATA(file_inode(file));
+	int err;
+
+	err = get_set_param(priv, buffer, count, LREDEV_ATTR_ID_PRP_TR);
+	if (err)
+		return err;
+
+	return  count;
+}
+
+static const struct proc_ops prp_tr_fops = {
+	.proc_open		= prp_tr_open,
+	.proc_read		= seq_read,
+	.proc_write		= prp_tr_store,
+	.proc_lseek		= seq_lseek,
+	.proc_release	= single_release,
+};
+
+static int dlrmt_show(struct seq_file *sfp, void *v)
+{
+	struct hsr_priv *priv = (struct hsr_priv *)sfp->private;
+	struct lredev_attr temp_attr;
+	int err;
+
+	if (!priv->rx_offloaded) {
+		seq_printf(sfp, "%u\n", priv->dlrmt);
+		return 0;
+	}
+
+	temp_attr.id = LREDEV_ATTR_ID_DLRMT;
+	err = hsr_lredev_attr_get(priv, &temp_attr);
+	if (err)
+		return err;
+
+	seq_printf(sfp, "%u\n", temp_attr.dl_reside_max_time);
+	return 0;
+}
+
+static int dlrmt_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, dlrmt_show, PDE_DATA(inode));
+}
+
+static ssize_t dlrmt_store(struct file *file,
+			   const char __user *buffer,
+			   size_t count, loff_t *pos)
+{
+	struct hsr_priv *priv = (struct hsr_priv *)PDE_DATA(file_inode(file));
+	int err;
+
+	err = get_set_param(priv, buffer, count, LREDEV_ATTR_ID_DLRMT);
+	if (err)
+		return err;
+
+	return  count;
+}
+
+static const struct proc_ops dlrmt_fops = {
+	.proc_open		= dlrmt_open,
+	.proc_read		= seq_read,
+	.proc_write		= dlrmt_store,
+	.proc_lseek		= seq_lseek,
+	.proc_release	= single_release,
+};
+
+static int dd_mode_show(struct seq_file *sfp, void *v)
+{
+	struct hsr_priv *priv = (struct hsr_priv *)sfp->private;
+	struct lredev_attr temp_attr;
+	int err;
+
+	if (!priv->rx_offloaded) {
+		seq_printf(sfp, "%u\n", priv->dd_mode);
+		return 0;
+	}
+
+	temp_attr.id = LREDEV_ATTR_ID_DD_MODE;
+	err = hsr_lredev_attr_get(priv, &temp_attr);
+	if (err)
+		return err;
+
+	seq_printf(sfp, "%u\n", temp_attr.dd_mode);
+	return 0;
+}
+
+static int dd_mode_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, dd_mode_show, PDE_DATA(inode));
+}
+
+static ssize_t dd_mode_store(struct file *file,
+			     const char __user *buffer,
+			     size_t count, loff_t *pos)
+{
+	struct hsr_priv *priv = (struct hsr_priv *)PDE_DATA(file_inode(file));
+	int err;
+
+	err = get_set_param(priv, buffer, count, LREDEV_ATTR_ID_DD_MODE);
+	if (err)
+		return err;
+
+	return  count;
+}
+
+static const struct proc_ops dd_mode_fops = {
+	.proc_open		= dd_mode_open,
+	.proc_read		= seq_read,
+	.proc_write		= dd_mode_store,
+	.proc_lseek		= seq_lseek,
+	.proc_release	= single_release,
+};
+
+static int clear_nt_show(struct seq_file *sfp, void *v)
+{
+	struct hsr_priv *priv = (struct hsr_priv *)sfp->private;
+	struct lredev_attr temp_attr;
+	int err;
+
+	if (!priv->rx_offloaded) {
+		seq_printf(sfp, "%u\n", priv->clear_nt_cmd);
+		return 0;
+	}
+
+	temp_attr.id = LREDEV_ATTR_ID_CLEAR_NT;
+	err = hsr_lredev_attr_get(priv, &temp_attr);
+	if (err)
+		return err;
+
+	seq_printf(sfp, "%u\n", temp_attr.clear_nt_cmd);
+	return 0;
+}
+
+static int clear_nt_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, clear_nt_show, PDE_DATA(inode));
+}
+
+static ssize_t clear_nt_store(struct file *file,
+			      const char __user *buffer,
+			      size_t count, loff_t *pos)
+{
+	struct hsr_priv *priv = (struct hsr_priv *)PDE_DATA(file_inode(file));
+	int err;
+
+	err = get_set_param(priv, buffer, count, LREDEV_ATTR_ID_CLEAR_NT);
+	if (err)
+		return err;
+
+	return  count;
+}
+
+static const struct proc_ops clear_nt_fops = {
+	.proc_open		= clear_nt_open,
+	.proc_read		= seq_read,
+	.proc_write		= clear_nt_store,
+	.proc_lseek		= seq_lseek,
+	.proc_release		= single_release,
+};
+
+static int disable_sv_show(struct seq_file *sfp, void *v)
+{
+	struct hsr_priv *priv = (struct hsr_priv *)sfp->private;
+
+	seq_printf(sfp, "%u\n", priv->disable_sv_frame);
+	return 0;
+}
+
+static int disable_sv_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, disable_sv_show, PDE_DATA(inode));
+}
+
+static ssize_t disable_sv_store(struct file *file,
+				const char __user *buffer,
+				size_t count, loff_t *pos)
+{
+	struct hsr_priv *priv = (struct hsr_priv *)PDE_DATA(file_inode(file));
+	char cmd_buffer[BUF_SIZE];
+	int ret = -EINVAL;
+	u32 val;
+
+	if (count > (sizeof(cmd_buffer) - 1))
+		goto err;
+
+	if (copy_from_user(cmd_buffer, buffer, count)) {
+		ret = -EFAULT;
+		goto err;
+	}
+	cmd_buffer[count] = '\0';
+	ret = kstrtou32(cmd_buffer, 0, &val);
+	if (ret < 0 || val > 1)
+		goto err;
+
+	priv->disable_sv_frame = val;
+
+	return  count;
+err:
+	return ret;
+}
+
+static const struct proc_ops disable_sv_fops = {
+	.proc_open		= disable_sv_open,
+	.proc_read		= seq_read,
+	.proc_write		= disable_sv_store,
+	.proc_lseek		= seq_lseek,
+	.proc_release	= single_release,
+};
+
+int hsr_create_procfs(struct hsr_priv *priv, struct net_device *ndev)
+{
+	int ret = -ENODEV;
+
+	priv->dir = proc_mkdir(ndev->name, NULL);
+	if (!priv->dir)
+		return ret;
+
+	priv->lre_stats_file = proc_create_data("lre-stats", 0444, priv->dir,
+						&hsr_lre_stats_fops,
+						(void *)priv);
+	if (!priv->lre_stats_file)
+		goto fail_lre_stats;
+
+	priv->node_table_file = proc_create_data("node-table", 0444, priv->dir,
+						 &hsr_node_table_fops,
+						 (void *)priv);
+	if (!priv->node_table_file)
+		goto fail_node_table;
+
+	priv->hsr_mode_file = proc_create_data("hsr-mode", 0644, priv->dir,
+					       &hsr_mode_fops, (void *)priv);
+	if (!priv->hsr_mode_file)
+		goto fail_hsr_mode;
+
+	priv->dd_mode_file = proc_create_data("dd-mode", 0644, priv->dir,
+					      &dd_mode_fops, (void *)priv);
+	if (!priv->dd_mode_file)
+		goto fail_dd_mode;
+
+	priv->prp_tr_file = proc_create_data("prp-tr", 0644, priv->dir,
+					     &prp_tr_fops, (void *)priv);
+	if (!priv->prp_tr_file)
+		goto fail_prp_tr;
+
+	priv->clear_nt_file = proc_create_data("clear-nt", 0644, priv->dir,
+					       &clear_nt_fops, (void *)priv);
+	if (!priv->clear_nt_file)
+		goto fail_clear_nt;
+
+	priv->dlrmt_file = proc_create_data("dlrmt", 0644, priv->dir,
+					    &dlrmt_fops, (void *)priv);
+	if (!priv->dlrmt_file)
+		goto fail_dlrmt;
+
+	priv->disable_sv_file = proc_create_data("disable-sv-frame", 0644,
+						 priv->dir, &disable_sv_fops,
+						 (void *)priv);
+	if (!priv->disable_sv_file)
+		goto fail_disable_sv;
+
+	return 0;
+fail_disable_sv:
+	if (priv->dlrmt_file)
+		remove_proc_entry("dlrmt", priv->dir);
+fail_dlrmt:
+	if (priv->clear_nt_file)
+		remove_proc_entry("clear-nt", priv->dir);
+fail_clear_nt:
+	if (priv->prp_tr_file)
+		remove_proc_entry("prp-tr", priv->dir);
+fail_prp_tr:
+	if (priv->dd_mode_file)
+		remove_proc_entry("dd-mode", priv->dir);
+fail_dd_mode:
+	if (priv->hsr_mode_file)
+		remove_proc_entry("hsr-mode", priv->dir);
+fail_hsr_mode:
+	if (priv->node_table_file)
+		remove_proc_entry("node-table", priv->dir);
+fail_node_table:
+	if (priv->lre_stats_file)
+		remove_proc_entry("lre-stats", priv->dir);
+fail_lre_stats:
+	remove_proc_entry(ndev->name, NULL);
+	return ret;
+}
+
+void hsr_remove_procfs(struct hsr_priv *priv, struct net_device *ndev)
+{
+	remove_proc_entry("disable-sv-frame", priv->dir);
+	remove_proc_entry("dlrmt", priv->dir);
+	remove_proc_entry("clear-nt", priv->dir);
+	remove_proc_entry("prp-tr", priv->dir);
+	remove_proc_entry("dd-mode", priv->dir);
+	remove_proc_entry("hsr-mode", priv->dir);
+	remove_proc_entry("lre-stats", priv->dir);
+	remove_proc_entry("node-table", priv->dir);
+	remove_proc_entry(ndev->name, NULL);
+	priv->dir = NULL;
+}
diff -Naur --no-dereference a/net/hsr/hsr_slave.c b/net/hsr/hsr_slave.c
--- a/net/hsr/hsr_slave.c	2023-01-04 05:39:24.000000000 -0500
+++ b/net/hsr/hsr_slave.c	2023-04-15 15:47:48.690088712 -0400
@@ -23,9 +23,9 @@
 
 static rx_handler_result_t hsr_handle_frame(struct sk_buff **pskb)
 {
+	struct hsr_priv *hsr = NULL;
 	struct sk_buff *skb = *pskb;
 	struct hsr_port *port;
-	struct hsr_priv *hsr;
 	__be16 protocol;
 
 	/* Packets from dev_loopback_xmit() do not have L2 header, bail out */
@@ -44,16 +44,19 @@
 
 	if (hsr_addr_is_self(port->hsr, eth_hdr(skb)->h_source)) {
 		/* Directly kill frames sent by ourselves */
+		INC_CNT_RX_ERROR_AB(port->type, port->hsr);
 		kfree_skb(skb);
 		goto finish_consume;
 	}
 
-	/* For HSR, only tagged frames are expected, but for PRP
-	 * there could be non tagged frames as well from Single
-	 * attached nodes (SANs).
+	/* For HSR, only tagged frames are expected (unless the device offloads
+	 * HSR tag removal), but for PRP there could be non tagged frames as
+	 * well from Single attached nodes (SANs).
 	 */
 	protocol = eth_hdr(skb)->h_proto;
-	if (hsr->proto_ops->invalid_dan_ingress_frame &&
+
+	if (!(port->dev->features & NETIF_F_HW_HSR_TAG_RM) &&
+	    hsr->proto_ops->invalid_dan_ingress_frame &&
 	    hsr->proto_ops->invalid_dan_ingress_frame(protocol))
 		goto finish_pass;
 
@@ -64,12 +67,15 @@
 		skb_set_network_header(skb, ETH_HLEN + HSR_HLEN);
 	skb_reset_mac_len(skb);
 
+	INC_CNT_RX_AB(port->type, hsr);
 	hsr_forward_skb(skb, port);
 
 finish_consume:
 	return RX_HANDLER_CONSUMED;
 
 finish_pass:
+	if (hsr)
+		INC_CNT_RX_ERROR_AB(port->type, hsr);
 	return RX_HANDLER_PASS;
 }
 
@@ -129,9 +135,14 @@
 	struct hsr_port *master;
 	int res;
 
-	res = dev_set_promiscuity(dev, 1);
-	if (res)
-		return res;
+	/* Don't use promiscuous mode for offload since L2 frame forward
+	 * happens at the offloaded hardware.
+	 */
+	if (!port->hsr->rx_offloaded) {
+		res = dev_set_promiscuity(dev, 1);
+		if (res)
+			return res;
+	}
 
 	master = hsr_port_get_hsr(hsr, HSR_PT_MASTER);
 	hsr_dev = master->dev;
@@ -150,7 +161,9 @@
 fail_rx_handler:
 	netdev_upper_dev_unlink(dev, hsr_dev);
 fail_upper_dev_link:
-	dev_set_promiscuity(dev, -1);
+	if (!port->hsr->rx_offloaded)
+		dev_set_promiscuity(dev, -1);
+
 	return res;
 }
 
diff -Naur --no-dereference a/net/hsr/Makefile b/net/hsr/Makefile
--- a/net/hsr/Makefile	2023-01-04 05:39:24.000000000 -0500
+++ b/net/hsr/Makefile	2023-04-15 15:47:48.690088712 -0400
@@ -8,3 +8,4 @@
 hsr-y			:= hsr_main.o hsr_framereg.o hsr_device.o \
 			   hsr_netlink.o hsr_slave.o hsr_forward.o
 hsr-$(CONFIG_DEBUG_FS) += hsr_debugfs.o
+hsr-$(CONFIG_PROC_FS) += hsr_proc.o
diff -Naur --no-dereference a/net/Kconfig b/net/Kconfig
--- a/net/Kconfig	2023-01-04 05:39:24.000000000 -0500
+++ b/net/Kconfig	2023-04-15 15:47:48.686088699 -0400
@@ -391,6 +391,7 @@
 source "net/rfkill/Kconfig"
 source "net/9p/Kconfig"
 source "net/caif/Kconfig"
+source "net/rpmsg/Kconfig"
 source "net/ceph/Kconfig"
 source "net/nfc/Kconfig"
 source "net/psample/Kconfig"
diff -Naur --no-dereference a/net/mac80211/aead_api.c b/net/mac80211/aead_api.c
--- a/net/mac80211/aead_api.c	2023-01-04 05:39:24.000000000 -0500
+++ b/net/mac80211/aead_api.c	2023-04-15 15:47:48.690088712 -0400
@@ -23,7 +23,6 @@
 	struct aead_request *aead_req;
 	int reqsize = sizeof(*aead_req) + crypto_aead_reqsize(tfm);
 	u8 *__aad;
-	int ret;
 
 	aead_req = kzalloc(reqsize + aad_len, GFP_ATOMIC);
 	if (!aead_req)
@@ -41,10 +40,10 @@
 	aead_request_set_crypt(aead_req, sg, sg, data_len, b_0);
 	aead_request_set_ad(aead_req, sg[0].length);
 
-	ret = crypto_aead_encrypt(aead_req);
+	crypto_aead_encrypt(aead_req);
 	kfree_sensitive(aead_req);
 
-	return ret;
+	return 0;
 }
 
 int aead_decrypt(struct crypto_aead *tfm, u8 *b_0, u8 *aad, size_t aad_len,
diff -Naur --no-dereference a/net/mac80211/aes_gmac.c b/net/mac80211/aes_gmac.c
--- a/net/mac80211/aes_gmac.c	2023-01-04 05:39:24.000000000 -0500
+++ b/net/mac80211/aes_gmac.c	2023-04-15 15:47:48.690088712 -0400
@@ -22,7 +22,6 @@
 	struct aead_request *aead_req;
 	int reqsize = sizeof(*aead_req) + crypto_aead_reqsize(tfm);
 	const __le16 *fc;
-	int ret;
 
 	if (data_len < GMAC_MIC_LEN)
 		return -EINVAL;
@@ -60,10 +59,10 @@
 	aead_request_set_crypt(aead_req, sg, sg, 0, iv);
 	aead_request_set_ad(aead_req, GMAC_AAD_LEN + data_len);
 
-	ret = crypto_aead_encrypt(aead_req);
+	crypto_aead_encrypt(aead_req);
 	kfree_sensitive(aead_req);
 
-	return ret;
+	return 0;
 }
 
 struct crypto_aead *ieee80211_aes_gmac_key_setup(const u8 key[],
diff -Naur --no-dereference a/net/mac80211/agg-rx.c b/net/mac80211/agg-rx.c
--- a/net/mac80211/agg-rx.c	2023-01-04 05:39:24.000000000 -0500
+++ b/net/mac80211/agg-rx.c	2023-04-15 15:47:48.690088712 -0400
@@ -9,7 +9,7 @@
  * Copyright 2007, Michael Wu <flamingice@sourmilk.net>
  * Copyright 2007-2010, Intel Corporation
  * Copyright(c) 2015-2017 Intel Deutschland GmbH
- * Copyright (C) 2018-2021 Intel Corporation
+ * Copyright (C) 2018-2020 Intel Corporation
  */
 
 /**
@@ -191,8 +191,7 @@
 	sband = ieee80211_get_sband(sdata);
 	if (!sband)
 		return;
-	he_cap = ieee80211_get_he_iftype_cap(sband,
-					     ieee80211_vif_type_p2p(&sdata->vif));
+	he_cap = ieee80211_get_he_iftype_cap(sband, sdata->vif.type);
 	if (!he_cap)
 		return;
 
diff -Naur --no-dereference a/net/mac80211/agg-tx.c b/net/mac80211/agg-tx.c
--- a/net/mac80211/agg-tx.c	2023-01-04 05:39:24.000000000 -0500
+++ b/net/mac80211/agg-tx.c	2023-04-15 15:47:48.690088712 -0400
@@ -9,7 +9,7 @@
  * Copyright 2007, Michael Wu <flamingice@sourmilk.net>
  * Copyright 2007-2010, Intel Corporation
  * Copyright(c) 2015-2017 Intel Deutschland GmbH
- * Copyright (C) 2018 - 2022 Intel Corporation
+ * Copyright (C) 2018 - 2020 Intel Corporation
  */
 
 #include <linux/ieee80211.h>
@@ -106,7 +106,7 @@
 	mgmt->u.action.u.addba_req.start_seq_num =
 					cpu_to_le16(start_seq_num << 4);
 
-	ieee80211_tx_skb_tid(sdata, skb, tid);
+	ieee80211_tx_skb(sdata, skb);
 }
 
 void ieee80211_send_bar(struct ieee80211_vif *vif, u8 *ra, u16 tid, u16 ssn)
@@ -213,8 +213,6 @@
 	struct ieee80211_txq *txq = sta->sta.txq[tid];
 	struct txq_info *txqi;
 
-	lockdep_assert_held(&sta->ampdu_mlme.mtx);
-
 	if (!txq)
 		return;
 
@@ -292,6 +290,7 @@
 	ieee80211_assign_tid_tx(sta, tid, NULL);
 
 	ieee80211_agg_splice_finish(sta->sdata, tid);
+	ieee80211_agg_start_txq(sta, tid, false);
 
 	kfree_rcu(tid_tx, rcu_head);
 }
@@ -481,7 +480,8 @@
 
 	/* send AddBA request */
 	ieee80211_send_addba_request(sdata, sta->sta.addr, tid,
-				     tid_tx->dialog_token, tid_tx->ssn,
+				     tid_tx->dialog_token,
+				     sta->tid_seq[tid] >> 4,
 				     buf_size, tid_tx->timeout);
 
 	WARN_ON(test_and_set_bit(HT_AGG_STATE_SENT_ADDBA, &tid_tx->state));
@@ -523,7 +523,6 @@
 
 	params.ssn = sta->tid_seq[tid] >> 4;
 	ret = drv_ampdu_action(local, sdata, &params);
-	tid_tx->ssn = params.ssn;
 	if (ret == IEEE80211_AMPDU_TX_START_DELAY_ADDBA) {
 		return;
 	} else if (ret == IEEE80211_AMPDU_TX_START_IMMEDIATE) {
@@ -626,14 +625,6 @@
 		return -EINVAL;
 	}
 
-	if (test_sta_flag(sta, WLAN_STA_MFP) &&
-	    !test_sta_flag(sta, WLAN_STA_AUTHORIZED)) {
-		ht_dbg(sdata,
-		       "MFP STA not authorized - deny BA session request %pM tid %d\n",
-		       sta->sta.addr, tid);
-		return -EINVAL;
-	}
-
 	/*
 	 * 802.11n-2009 11.5.1.1: If the initiating STA is an HT STA, is a
 	 * member of an IBSS, and has no other existing Block Ack agreement
@@ -898,7 +889,6 @@
 {
 	struct ieee80211_sub_if_data *sdata = sta->sdata;
 	bool send_delba = false;
-	bool start_txq = false;
 
 	ht_dbg(sdata, "Stopping Tx BA session for %pM tid %d\n",
 	       sta->sta.addr, tid);
@@ -916,14 +906,10 @@
 		send_delba = true;
 
 	ieee80211_remove_tid_tx(sta, tid);
-	start_txq = true;
 
  unlock_sta:
 	spin_unlock_bh(&sta->lock);
 
-	if (start_txq)
-		ieee80211_agg_start_txq(sta, tid, false);
-
 	if (send_delba)
 		ieee80211_send_delba(sdata, sta->sta.addr, tid,
 			WLAN_BACK_INITIATOR, WLAN_REASON_QSTA_NOT_USE);
diff -Naur --no-dereference a/net/mac80211/airtime.c b/net/mac80211/airtime.c
--- a/net/mac80211/airtime.c	2023-01-04 05:39:24.000000000 -0500
+++ b/net/mac80211/airtime.c	2023-04-15 15:47:48.690088712 -0400
@@ -457,9 +457,6 @@
 			 (status->encoding == RX_ENC_HE && streams > 8)))
 		return 0;
 
-	if (idx >= MCS_GROUP_RATES)
-		return 0;
-
 	duration = airtime_mcs_groups[group].duration[idx];
 	duration <<= airtime_mcs_groups[group].shift;
 	*overhead = 36 + (streams << 2);
diff -Naur --no-dereference a/net/mac80211/cfg.c b/net/mac80211/cfg.c
--- a/net/mac80211/cfg.c	2023-01-04 05:39:24.000000000 -0500
+++ b/net/mac80211/cfg.c	2023-04-15 15:47:48.690088712 -0400
@@ -152,8 +152,6 @@
 				  struct vif_params *params)
 {
 	struct ieee80211_sub_if_data *sdata = IEEE80211_DEV_TO_SUB_IF(dev);
-	struct ieee80211_local *local = sdata->local;
-	struct sta_info *sta;
 	int ret;
 
 	ret = ieee80211_if_change_type(sdata, type);
@@ -164,24 +162,7 @@
 		RCU_INIT_POINTER(sdata->u.vlan.sta, NULL);
 		ieee80211_check_fast_rx_iface(sdata);
 	} else if (type == NL80211_IFTYPE_STATION && params->use_4addr >= 0) {
-		struct ieee80211_if_managed *ifmgd = &sdata->u.mgd;
-
-		if (params->use_4addr == ifmgd->use_4addr)
-			return 0;
-
 		sdata->u.mgd.use_4addr = params->use_4addr;
-		if (!ifmgd->associated)
-			return 0;
-
-		mutex_lock(&local->sta_mtx);
-		sta = sta_info_get(sdata, ifmgd->bssid);
-		if (sta)
-			drv_sta_set_4addr(local, sdata, &sta->sta,
-					  params->use_4addr);
-		mutex_unlock(&local->sta_mtx);
-
-		if (params->use_4addr)
-			ieee80211_send_4addr_nullfunc(local, sdata);
 	}
 
 	if (sdata->vif.type == NL80211_IFTYPE_MONITOR) {
@@ -1217,10 +1198,7 @@
 	return 0;
 
 error:
-	mutex_lock(&local->mtx);
 	ieee80211_vif_release_channel(sdata);
-	mutex_unlock(&local->mtx);
-
 	return err;
 }
 
@@ -1811,10 +1789,8 @@
 		}
 
 		if (sta->sdata->vif.type == NL80211_IFTYPE_AP_VLAN &&
-		    sta->sdata->u.vlan.sta) {
-			ieee80211_clear_fast_rx(sta);
+		    sta->sdata->u.vlan.sta)
 			RCU_INIT_POINTER(sta->sdata->u.vlan.sta, NULL);
-		}
 
 		if (test_sta_flag(sta, WLAN_STA_AUTHORIZED))
 			ieee80211_vif_dec_num_mcast(sta->sdata);
@@ -2076,12 +2052,14 @@
 		const struct mesh_setup *setup)
 {
 	u8 *new_ie;
+	const u8 *old_ie;
 	struct ieee80211_sub_if_data *sdata = container_of(ifmsh,
 					struct ieee80211_sub_if_data, u.mesh);
 	int i;
 
 	/* allocate information elements */
 	new_ie = NULL;
+	old_ie = ifmsh->ie;
 
 	if (setup->ie_len) {
 		new_ie = kmemdup(setup->ie, setup->ie_len,
@@ -2091,6 +2069,7 @@
 	}
 	ifmsh->ie_len = setup->ie_len;
 	ifmsh->ie = new_ie;
+	kfree(old_ie);
 
 	/* now copy the rest of the setup parameters */
 	ifmsh->mesh_id_len = setup->mesh_id_len;
@@ -2982,14 +2961,14 @@
 			continue;
 
 		for (j = 0; j < IEEE80211_HT_MCS_MASK_LEN; j++) {
-			if (sdata->rc_rateidx_mcs_mask[i][j] != 0xff) {
+			if (~sdata->rc_rateidx_mcs_mask[i][j]) {
 				sdata->rc_has_mcs_mask[i] = true;
 				break;
 			}
 		}
 
 		for (j = 0; j < NL80211_VHT_NSS_MAX; j++) {
-			if (sdata->rc_rateidx_vht_mcs_mask[i][j] != 0xffff) {
+			if (~sdata->rc_rateidx_vht_mcs_mask[i][j]) {
 				sdata->rc_has_vht_mcs_mask[i] = true;
 				break;
 			}
@@ -3357,6 +3336,9 @@
 	case NL80211_IFTYPE_MESH_POINT: {
 		struct ieee80211_if_mesh *ifmsh = &sdata->u.mesh;
 
+		if (params->chandef.width != sdata->vif.bss_conf.chandef.width)
+			return -EINVAL;
+
 		/* changes into another band are not supported */
 		if (sdata->vif.bss_conf.chandef.chan->band !=
 		    params->chandef.chan->band)
diff -Naur --no-dereference a/net/mac80211/chan.c b/net/mac80211/chan.c
--- a/net/mac80211/chan.c	2023-01-04 05:39:24.000000000 -0500
+++ b/net/mac80211/chan.c	2023-04-15 15:47:48.690088712 -0400
@@ -1652,9 +1652,12 @@
 
 	if (new_ctx->replace_state == IEEE80211_CHANCTX_REPLACE_NONE) {
 		if (old_ctx)
-			return ieee80211_vif_use_reserved_reassign(sdata);
+			err = ieee80211_vif_use_reserved_reassign(sdata);
+		else
+			err = ieee80211_vif_use_reserved_assign(sdata);
 
-		return ieee80211_vif_use_reserved_assign(sdata);
+		if (err)
+			return err;
 	}
 
 	/*
diff -Naur --no-dereference a/net/mac80211/debugfs.c b/net/mac80211/debugfs.c
--- a/net/mac80211/debugfs.c	2023-01-04 05:39:24.000000000 -0500
+++ b/net/mac80211/debugfs.c	2023-04-15 15:47:48.690088712 -0400
@@ -120,17 +120,18 @@
 {
 	struct ieee80211_local *local = file->private_data;
 	char buf[100];
+	size_t len;
 
-	if (count >= sizeof(buf))
+	if (count > sizeof(buf))
 		return -EINVAL;
 
 	if (copy_from_user(buf, user_buf, count))
 		return -EFAULT;
 
-	if (count && buf[count - 1] == '\n')
-		buf[count - 1] = '\0';
-	else
-		buf[count] = '\0';
+	buf[sizeof(buf) - 1] = '\0';
+	len = strlen(buf);
+	if (len > 0 && buf[len-1] == '\n')
+		buf[len-1] = 0;
 
 	if (sscanf(buf, "fq_limit %u", &local->fq.limit) == 1)
 		return count;
@@ -176,17 +177,18 @@
 {
 	struct ieee80211_local *local = file->private_data;
 	char buf[16];
+	size_t len;
 
-	if (count >= sizeof(buf))
+	if (count > sizeof(buf))
 		return -EINVAL;
 
 	if (copy_from_user(buf, user_buf, count))
 		return -EFAULT;
 
-	if (count && buf[count - 1] == '\n')
-		buf[count - 1] = '\0';
-	else
-		buf[count] = '\0';
+	buf[sizeof(buf) - 1] = 0;
+	len = strlen(buf);
+	if (len > 0 && buf[len - 1] == '\n')
+		buf[len - 1] = 0;
 
 	if (kstrtou16(buf, 0, &local->airtime_flags))
 		return -EINVAL;
@@ -235,19 +237,20 @@
 {
 	struct ieee80211_local *local = file->private_data;
 	char buf[100];
+	size_t len;
 	u32 ac, q_limit_low, q_limit_high, q_limit_low_old, q_limit_high_old;
 	struct sta_info *sta;
 
-	if (count >= sizeof(buf))
+	if (count > sizeof(buf))
 		return -EINVAL;
 
 	if (copy_from_user(buf, user_buf, count))
 		return -EFAULT;
 
-	if (count && buf[count - 1] == '\n')
-		buf[count - 1] = '\0';
-	else
-		buf[count] = '\0';
+	buf[sizeof(buf) - 1] = 0;
+	len = strlen(buf);
+	if (len > 0 && buf[len - 1] == '\n')
+		buf[len - 1] = 0;
 
 	if (sscanf(buf, "%u %u %u", &ac, &q_limit_low, &q_limit_high) != 3)
 		return -EINVAL;
@@ -303,17 +306,18 @@
 {
 	struct ieee80211_local *local = file->private_data;
 	char buf[3];
+	size_t len;
 
-	if (count >= sizeof(buf))
+	if (count > sizeof(buf))
 		return -EINVAL;
 
 	if (copy_from_user(buf, user_buf, count))
 		return -EFAULT;
 
-	if (count && buf[count - 1] == '\n')
-		buf[count - 1] = '\0';
-	else
-		buf[count] = '\0';
+	buf[sizeof(buf) - 1] = '\0';
+	len = strlen(buf);
+	if (len > 0 && buf[len - 1] == '\n')
+		buf[len - 1] = 0;
 
 	if (buf[0] == '0' && buf[1] == '\0')
 		local->force_tx_status = 0;
diff -Naur --no-dereference a/net/mac80211/driver-ops.c b/net/mac80211/driver-ops.c
--- a/net/mac80211/driver-ops.c	2023-01-04 05:39:24.000000000 -0500
+++ b/net/mac80211/driver-ops.c	2023-04-15 15:47:48.690088712 -0400
@@ -125,11 +125,8 @@
 	} else if (old_state == IEEE80211_STA_AUTH &&
 		   new_state == IEEE80211_STA_ASSOC) {
 		ret = drv_sta_add(local, sdata, &sta->sta);
-		if (ret == 0) {
+		if (ret == 0)
 			sta->uploaded = true;
-			if (rcu_access_pointer(sta->sta.rates))
-				drv_sta_rate_tbl_update(local, sdata, &sta->sta);
-		}
 	} else if (old_state == IEEE80211_STA_ASSOC &&
 		   new_state == IEEE80211_STA_AUTH) {
 		drv_sta_remove(local, sdata, &sta->sta);
